Index: NEMO/branches/2020/dev_12905_xios_restart/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/2020/dev_12905_xios_restart/src/OCE/IOM/iom.F90	(revision 13750)
+++ NEMO/branches/2020/dev_12905_xios_restart/src/OCE/IOM/iom.F90	(revision 13871)
@@ -141,11 +141,11 @@
       CALL iom_swap( cdname )
 
-      llrstr = (TRIM(cdname) == TRIM(crxios_context)) .OR. (TRIM(cdname) == TRIM(crixios_context))
-      llrstr = llrstr .OR. (TRIM(cdname) == TRIM(crtxios_context))
-      llrstr = llrstr .OR. (TRIM(cdname) == TRIM(crsxios_context))
-
-      llrstw = (TRIM(cdname) == TRIM(cwxios_context)) .OR. (TRIM(cdname) == TRIM(cwixios_context))
-      llrstw = llrstw .OR. (TRIM(cdname) == TRIM(cwtxios_context))
-      llrstw = llrstw .OR. (TRIM(cdname) == TRIM(cwsxios_context))
+      llrstr = (cdname == cr_ocerst_cxt) .OR. (cdname == cr_icerst_cxt)
+      llrstr = llrstr .OR. (cdname == cr_toprst_cxt)
+      llrstr = llrstr .OR. (cdname == cr_sedrst_cxt)
+
+      llrstw = (cdname == cw_ocerst_cxt) .OR. (cdname == cw_icerst_cxt)
+      llrstw = llrstw .OR. (cdname == cw_toprst_cxt)
+      llrstw = llrstw .OR. (cdname == cw_sedrst_cxt)
 
       llrst_context = llrstr .OR. llrstw
@@ -168,5 +168,5 @@
       IF(.NOT.llrst_context) CALL set_scalar
       !
-      IF( TRIM(cdname) == TRIM(cxios_context) ) THEN  
+      IF( cdname == cxios_context ) THEN  
          CALL set_grid( "T", glamt, gphit, .FALSE., .FALSE. ) 
          CALL set_grid( "U", glamu, gphiu, .FALSE., .FALSE. )
@@ -212,70 +212,70 @@
       ! vertical grid definition
       IF(.NOT.llrst_context) THEN
-          CALL iom_set_axis_attr(  "deptht", paxis = gdept_1d )
-          CALL iom_set_axis_attr(  "depthu", paxis = gdept_1d )
-          CALL iom_set_axis_attr(  "depthv", paxis = gdept_1d )
-          CALL iom_set_axis_attr(  "depthw", paxis = gdepw_1d )
+         CALL iom_set_axis_attr(  "deptht", paxis = gdept_1d )
+         CALL iom_set_axis_attr(  "depthu", paxis = gdept_1d )
+         CALL iom_set_axis_attr(  "depthv", paxis = gdept_1d )
+         CALL iom_set_axis_attr(  "depthw", paxis = gdepw_1d )
 
           ! ABL
-          IF( .NOT. ALLOCATED(ght_abl) ) THEN   ! force definition for xml files (xios) 
-             ALLOCATE( ght_abl(jpka), ghw_abl(jpka), e3t_abl(jpka), e3w_abl(jpka) )   ! default allocation needed by iom
-             ght_abl(:) = -1._wp   ;   ghw_abl(:) = -1._wp
-             e3t_abl(:) = -1._wp   ;   e3w_abl(:) = -1._wp
-          ENDIF
-          CALL iom_set_axis_attr( "ght_abl", ght_abl(2:jpka) )
-          CALL iom_set_axis_attr( "ghw_abl", ghw_abl(2:jpka) )
+         IF( .NOT. ALLOCATED(ght_abl) ) THEN   ! force definition for xml files (xios) 
+            ALLOCATE( ght_abl(jpka), ghw_abl(jpka), e3t_abl(jpka), e3w_abl(jpka) )   ! default allocation needed by iom
+            ght_abl(:) = -1._wp   ;   ghw_abl(:) = -1._wp
+            e3t_abl(:) = -1._wp   ;   e3w_abl(:) = -1._wp
+         ENDIF
+         CALL iom_set_axis_attr( "ght_abl", ght_abl(2:jpka) )
+         CALL iom_set_axis_attr( "ghw_abl", ghw_abl(2:jpka) )
           
-          ! Add vertical grid bounds
-          zt_bnds(2,:      ) = gdept_1d(:)
-          zt_bnds(1,2:jpk  ) = gdept_1d(1:jpkm1)
-          zt_bnds(1,1      ) = gdept_1d(1) - e3w_1d(1)
-          zw_bnds(1,:      ) = gdepw_1d(:)
-          zw_bnds(2,1:jpkm1) = gdepw_1d(2:jpk)
-          zw_bnds(2,jpk:   ) = gdepw_1d(jpk) + e3t_1d(jpk)
-          CALL iom_set_axis_attr(  "deptht", bounds=zw_bnds )
-          CALL iom_set_axis_attr(  "depthu", bounds=zw_bnds )
-          CALL iom_set_axis_attr(  "depthv", bounds=zw_bnds )
-          CALL iom_set_axis_attr(  "depthw", bounds=zt_bnds )
-
-          ! ABL
-          za_bnds(1,:) = ghw_abl(1:jpkam1)
-          za_bnds(2,:) = ghw_abl(2:jpka  )
-          CALL iom_set_axis_attr( "ght_abl", bounds=za_bnds )
-          za_bnds(1,:) = ght_abl(2:jpka  )
-          za_bnds(2,:) = ght_abl(2:jpka  ) + e3w_abl(2:jpka)
-          CALL iom_set_axis_attr( "ghw_abl", bounds=za_bnds )
-
-          CALL iom_set_axis_attr(  "nfloat", (/ (REAL(ji,wp), ji=1,jpnfl) /) )
+         ! Add vertical grid bounds
+         zt_bnds(2,:      ) = gdept_1d(:)
+         zt_bnds(1,2:jpk  ) = gdept_1d(1:jpkm1)
+         zt_bnds(1,1      ) = gdept_1d(1) - e3w_1d(1)
+         zw_bnds(1,:      ) = gdepw_1d(:)
+         zw_bnds(2,1:jpkm1) = gdepw_1d(2:jpk)
+         zw_bnds(2,jpk:   ) = gdepw_1d(jpk) + e3t_1d(jpk)
+         CALL iom_set_axis_attr(  "deptht", bounds=zw_bnds )
+         CALL iom_set_axis_attr(  "depthu", bounds=zw_bnds )
+         CALL iom_set_axis_attr(  "depthv", bounds=zw_bnds )
+         CALL iom_set_axis_attr(  "depthw", bounds=zt_bnds )
+
+         ! ABL
+         za_bnds(1,:) = ghw_abl(1:jpkam1)
+         za_bnds(2,:) = ghw_abl(2:jpka  )
+         CALL iom_set_axis_attr( "ght_abl", bounds=za_bnds )
+         za_bnds(1,:) = ght_abl(2:jpka  )
+         za_bnds(2,:) = ght_abl(2:jpka  ) + e3w_abl(2:jpka)
+         CALL iom_set_axis_attr( "ghw_abl", bounds=za_bnds )
+
+         CALL iom_set_axis_attr(  "nfloat", (/ (REAL(ji,wp), ji=1,jpnfl) /) )
 # if defined key_si3
-          CALL iom_set_axis_attr( "ncatice", (/ (REAL(ji,wp), ji=1,jpl) /) )
-          ! SIMIP diagnostics (4 main arctic straits)
-          CALL iom_set_axis_attr( "nstrait", (/ (REAL(ji,wp), ji=1,4) /) )
+         CALL iom_set_axis_attr( "ncatice", (/ (REAL(ji,wp), ji=1,jpl) /) )
+         ! SIMIP diagnostics (4 main arctic straits)
+         CALL iom_set_axis_attr( "nstrait", (/ (REAL(ji,wp), ji=1,4) /) )
 # endif
 #if defined key_top
-          IF( ALLOCATED(profsed) ) CALL iom_set_axis_attr( "profsed", paxis = profsed )
-#endif
-          CALL iom_set_axis_attr( "icbcla", class_num )
-          CALL iom_set_axis_attr( "iax_20C", (/ REAL(20,wp) /) )   ! strange syntaxe and idea...
-          CALL iom_set_axis_attr( "iax_26C", (/ REAL(26,wp) /) )   ! strange syntaxe and idea...
-          CALL iom_set_axis_attr( "iax_28C", (/ REAL(28,wp) /) )   ! strange syntaxe and idea...
-          ! for diaprt, we need to define an axis which size can be 1 (default) or 5 (if the file subbasins.nc exists)
-          INQUIRE( FILE = 'subbasins.nc', EXIST = ll_exist )
-          nbasin = 1 + 4 * COUNT( (/ll_exist/) )
-          CALL iom_set_axis_attr( "basin"  , (/ (REAL(ji,wp), ji=1,nbasin) /) )
+         IF( ALLOCATED(profsed) ) CALL iom_set_axis_attr( "profsed", paxis = profsed )
+#endif
+         CALL iom_set_axis_attr( "icbcla", class_num )
+         CALL iom_set_axis_attr( "iax_20C", (/ REAL(20,wp) /) )   ! strange syntaxe and idea...
+         CALL iom_set_axis_attr( "iax_26C", (/ REAL(26,wp) /) )   ! strange syntaxe and idea...
+         CALL iom_set_axis_attr( "iax_28C", (/ REAL(28,wp) /) )   ! strange syntaxe and idea...
+         ! for diaprt, we need to define an axis which size can be 1 (default) or 5 (if the file subbasins.nc exists)
+         INQUIRE( FILE = 'subbasins.nc', EXIST = ll_exist )
+         nbasin = 1 + 4 * COUNT( (/ll_exist/) )
+         CALL iom_set_axis_attr( "basin"  , (/ (REAL(ji,wp), ji=1,nbasin) /) )
       ENDIF
       !
       ! automatic definitions of some of the xml attributs
       IF(llrstr) THEN
-          IF(PRESENT(idfp)) THEN
-             CALL iom_set_rst_context(.TRUE.)
+         IF(PRESENT(idfp)) THEN
+            CALL iom_set_rst_context(.TRUE.)
 !set which fields will be read from restart file
-             CALL iom_set_vars_active(fname, idfp)
-          ELSE
-             CALL ctl_stop( 'iom_init:', 'restart read with XIOS: missing pointer to NETCDF file' )
-          ENDIF
+            CALL iom_set_vars_active(fname, idfp)
+         ELSE
+            CALL ctl_stop( 'iom_init:', 'restart read with XIOS: missing pointer to NETCDF file' )
+         ENDIF
       ELSE IF(llrstw) THEN
-          CALL iom_set_rstw_file(fname)
+         CALL iom_set_rstw_file(fname)
       ELSE
-          CALL set_xmlatt
+         CALL set_xmlatt
       ENDIF
       !
@@ -301,23 +301,23 @@
       !!
       !!----------------------------------------------------------------------
-   CHARACTER(len=*), OPTIONAL, INTENT(IN) :: cdname
+      CHARACTER(len=*), OPTIONAL, INTENT(IN) :: cdname
 #if defined key_iomput
-   LOGICAL :: llrstw
+      LOGICAL :: llrstw
 
       llrstw = .FALSE.
       IF(PRESENT(cdname)) THEN
-         llrstw = (TRIM(cdname) == TRIM(cwxios_context))
-         llrstw = llrstw .OR. (TRIM(cdname) == TRIM(cwixios_context))
-         llrstw = llrstw .OR. (TRIM(cdname) == TRIM(cwtxios_context))
-         llrstw = llrstw .OR. (TRIM(cdname) == TRIM(cwsxios_context))
+         llrstw = (cdname == cw_ocerst_cxt)
+         llrstw = llrstw .OR. (cdname == cw_icerst_cxt)
+         llrstw = llrstw .OR. (cdname == cw_toprst_cxt)
+         llrstw = llrstw .OR. (cdname == cw_sedrst_cxt)
       ENDIF
 
       IF( llrstw ) THEN
 !set names of the fields in restart file IF using XIOS to write data
-          CALL iom_set_rst_context(.FALSE.)
-          CALL xios_close_context_definition()
+         CALL iom_set_rst_context(.FALSE.)
+         CALL xios_close_context_definition()
       ELSE
-          CALL xios_close_context_definition()
-          CALL xios_update_calendar( 0 )
+         CALL xios_close_context_definition()
+         CALL xios_update_calendar( 0 )
       ENDIF
 #else
@@ -335,85 +335,92 @@
       !!               id of the file is assumed to be rrestart.
       !!---------------------------------------------------------------------
-
-   CHARACTER(len=*), INTENT(IN) :: cdfname
-   INTEGER         , INTENT(IN) :: idnum 
+      CHARACTER(len=*), INTENT(IN) :: cdfname
+      INTEGER         , INTENT(IN) :: idnum 
 #if defined key_iomput
-   INTEGER                                    :: ndims, nvars, natts, unlimitedDimId, dimlen, xtype,mdims
-   TYPE(xios_field)                           :: field_hdl
-   TYPE(xios_file)                            :: file_hdl
-   TYPE(xios_filegroup)                       :: filegroup_hdl
-   INTEGER                                    :: dimids(4), jv,i, idim
-   CHARACTER(LEN=256)                         :: clinfo               ! info character
-   INTEGER, ALLOCATABLE                       :: indimlens(:)
-   CHARACTER(LEN=nf90_max_name), ALLOCATABLE  :: indimnames(:)
-   CHARACTER(LEN=nf90_max_name)               :: dimname, varname
-   LOGICAL                                    :: lmeta
-
-        meta(1) = "nav_lat"
-        meta(2) = "nav_lon"
-        meta(3) = "nav_lev"
-        meta(4) = "time_instant"
-        meta(5) = "time_instant_bounds"
-        meta(6) = "time_counter"
-        meta(7) = "time_counter_bounds"
-        meta(8) = "x"
-        meta(9) = "y"
-        meta(10) = "numcat"
-
-        clinfo = '          iom_set_vars_active, file: '//TRIM(cdfname)
+      INTEGER                                    :: ndims, nvars, natts, unlimitedDimId, dimlen, xtype,mdims
+      TYPE(xios_field)                           :: field_hdl
+      TYPE(xios_file)                            :: file_hdl
+      TYPE(xios_filegroup)                       :: filegroup_hdl
+      INTEGER                                    :: dimids(4), jv,i, idim
+      CHARACTER(LEN=256)                         :: clinfo               ! info character
+      INTEGER, ALLOCATABLE                       :: indimlens(:)
+      CHARACTER(LEN=nf90_max_name), ALLOCATABLE  :: indimnames(:)
+      CHARACTER(LEN=nf90_max_name)               :: dimname, varname
+      LOGICAL                                    :: lmeta
+!metadata in restart file for restart read with XIOS
+      INTEGER, PARAMETER :: NMETA = 10
+      CHARACTER(LEN=lc)  :: meta(NMETA)
+
+
+      meta(1) = "nav_lat"
+      meta(2) = "nav_lon"
+      meta(3) = "nav_lev"
+      meta(4) = "time_instant"
+      meta(5) = "time_instant_bounds"
+      meta(6) = "time_counter"
+      meta(7) = "time_counter_bounds"
+      meta(8) = "x"
+      meta(9) = "y"
+      meta(10) = "numcat"
+
+      clinfo = '          iom_set_vars_active, file: '//TRIM(cdfname)
 
 !set name of the restart file and enable available fields
-        CALL xios_get_handle("file_definition", filegroup_hdl )
-        CALL xios_add_child(filegroup_hdl, file_hdl, 'rrestart')
-        CALL xios_set_file_attr( "rrestart", name=trim(cdfname), type="one_file", &
-             par_access="collective", enabled=.TRUE., mode="read",                 &
-             output_freq=xios_timestep)
-
-        CALL iom_nf90_check( nf90_inquire(idnum, ndims, nvars, natts ), clinfo )
-        ALLOCATE(indimlens(ndims), indimnames(ndims))
-        CALL iom_nf90_check( nf90_inquire(idnum, unlimitedDimId = unlimitedDimId ), clinfo )
-
-        DO idim = 1, ndims
-           CALL iom_nf90_check( nf90_inquire_dimension(idnum, idim, dimname, dimlen ), clinfo )
-           indimlens(idim) = dimlen
-           indimnames(idim) = dimname
-        ENDDO
-
-        DO jv =1, nvars
-            lmeta = .FALSE.
-            CALL iom_nf90_check( nf90_inquire_variable(idnum, jv, varname, xtype, ndims, dimids, natts ), clinfo )
-            DO i = 1, NMETA
-               IF(TRIM(varname) == TRIM(meta(i))) THEN
-                  lmeta = .TRUE.
-               ENDIF
-            ENDDO
-            IF(.NOT.lmeta) THEN
-               CALL xios_add_child(file_hdl, field_hdl, TRIM(varname))
-               mdims = ndims
-
-               IF(ANY(dimids(1:ndims) == unlimitedDimId)) THEN
-                mdims = mdims - 1
-               ENDIF
-
-               IF(mdims == 3) THEN
-                      CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(varname),   &
-                                   domain_ref="grid_N", axis_ref=TRIM(iom_axis(indimlens(dimids(mdims)))), &
-                                   prec = 8, operation = "instant")
-               ELSEIF(mdims == 2) THEN
-                      CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(varname), &
-                                          domain_ref="grid_N", prec = 8, operation = "instant") 
-               ELSEIF(mdims == 1) THEN
-                      CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(varname), &
-                                          axis_ref=TRIM(iom_axis(indimlens(dimids(mdims)))), prec = 8, operation = "instant")
-               ELSEIF(mdims == 0) THEN
-                      CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(varname), &
-                                                scalar_ref = "grid_scalar", prec = 8, operation = "instant")
-               ELSE
-                      WRITE(ctmp1,*) 'iom_set_vars_active: variable ', TRIM(varname) ,' incorrect number of dimensions' 
-                      CALL ctl_stop( 'iom_set_vars_active:', ctmp1 )
-               ENDIF
+      CALL xios_get_handle("file_definition", filegroup_hdl )
+      CALL xios_add_child(filegroup_hdl, file_hdl, 'rrestart')
+      CALL xios_set_file_attr( "rrestart", name=trim(cdfname), type="one_file", &
+           par_access="collective", enabled=.TRUE., mode="read",                &
+                                                    output_freq=xios_timestep   )
+
+      CALL iom_nf90_check( nf90_inquire(idnum, ndims, nvars, natts ), clinfo )
+      ALLOCATE(indimlens(ndims), indimnames(ndims))
+      CALL iom_nf90_check( nf90_inquire(idnum, unlimitedDimId = unlimitedDimId ), clinfo )
+
+      DO idim = 1, ndims
+         CALL iom_nf90_check( nf90_inquire_dimension(idnum, idim, dimname, dimlen ), clinfo )
+         indimlens(idim) = dimlen
+         indimnames(idim) = dimname
+      ENDDO
+
+      DO jv =1, nvars
+         lmeta = .FALSE.
+         CALL iom_nf90_check( nf90_inquire_variable(idnum, jv, varname, xtype, ndims, dimids, natts ), clinfo )
+         DO i = 1, NMETA
+           IF(varname == meta(i)) THEN
+             lmeta = .TRUE.
+           ENDIF
+         ENDDO
+         IF(.NOT.lmeta) THEN
+            CALL xios_add_child(file_hdl, field_hdl, varname)
+            mdims = ndims
+
+            IF(ANY(dimids(1:ndims) == unlimitedDimId)) THEN
+               mdims = mdims - 1
             ENDIF
-        ENDDO
-        DEALLOCATE(indimlens, indimnames)
+
+            IF(mdims == 3) THEN
+               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = varname,   &
+                                   domain_ref="grid_N",                           &
+                                   axis_ref=iom_axis(indimlens(dimids(mdims))),   &
+                                   prec = 8, operation = "instant"                )
+            ELSEIF(mdims == 2) THEN
+               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = varname,  &
+                                   domain_ref="grid_N", prec = 8,                &
+                                   operation = "instant"                         ) 
+            ELSEIF(mdims == 1) THEN
+               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = varname, &
+                                   axis_ref=iom_axis(indimlens(dimids(mdims))), &
+                                   prec = 8, operation = "instant"              )
+            ELSEIF(mdims == 0) THEN
+               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = varname, &
+                                   scalar_ref = "grid_scalar", prec = 8,        &
+                                   operation = "instant"                        )
+            ELSE
+               WRITE(ctmp1,*) 'iom_set_vars_active: variable ', TRIM(varname) ,' incorrect number of dimensions' 
+               CALL ctl_stop( 'iom_set_vars_active:', ctmp1 )
+            ENDIF
+         ENDIF
+      ENDDO
+      DEALLOCATE(indimlens, indimnames)
 #endif
    END SUBROUTINE iom_set_vars_active
@@ -425,25 +432,23 @@
       !! ** Purpose :  define file name in XIOS context for writing restart
       !!---------------------------------------------------------------------
-   CHARACTER(len=*) :: cdrst_file
+      CHARACTER(len=*) :: cdrst_file
 #if defined key_iomput
-   TYPE(xios_file) :: file_hdl
-   TYPE(xios_filegroup) :: filegroup_hdl
-   INTEGER :: i
-   CHARACTER(lc)  ::   clpath
+      TYPE(xios_file) :: file_hdl
+      TYPE(xios_filegroup) :: filegroup_hdl
 
 !set name of the restart file and enable available fields
-        IF(lwp) WRITE(numout,*) 'Setting restart filename (for XIOS write) to: ',cdrst_file
-        CALL xios_get_handle("file_definition", filegroup_hdl )
-        CALL xios_add_child(filegroup_hdl, file_hdl, 'wrestart')
-        IF(nxioso.eq.1) THEN 
-           CALL xios_set_file_attr( "wrestart", type="one_file", enabled=.TRUE.,& 
-                                    mode="write", output_freq=xios_timestep) 
-           if(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in one_file mode' 
-        ELSE  
-           CALL xios_set_file_attr( "wrestart", type="multiple_file", enabled=.TRUE.,& 
-                                    mode="write", output_freq=xios_timestep) 
-           if(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in multiple_file mode' 
-        ENDIF 
-        CALL xios_set_file_attr( "wrestart", name=trim(cdrst_file))
+      IF(lwp) WRITE(numout,*) 'Setting restart filename (for XIOS write) to: ',cdrst_file
+      CALL xios_get_handle("file_definition", filegroup_hdl )
+      CALL xios_add_child(filegroup_hdl, file_hdl, 'wrestart')
+      IF(nxioso.eq.1) THEN 
+         CALL xios_set_file_attr( "wrestart", type="one_file", enabled=.TRUE.,& 
+                                       mode="write", output_freq=xios_timestep) 
+         IF(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in one_file mode' 
+      ELSE  
+         CALL xios_set_file_attr( "wrestart", type="multiple_file", enabled=.TRUE.,& 
+                                            mode="write", output_freq=xios_timestep) 
+         IF(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in multiple_file mode' 
+      ENDIF 
+      CALL xios_set_file_attr( "wrestart", name=trim(cdrst_file))
 #endif
    END SUBROUTINE iom_set_rstw_file
@@ -458,52 +463,56 @@
       !!---------------------------------------------------------------------
 !sets enabled = .TRUE. for each field in restart file
-   CHARACTER(len = *), INTENT(IN)                     :: sdfield
-   REAL(dp), OPTIONAL, INTENT(IN)                     :: rd0
-   REAL(sp), OPTIONAL, INTENT(IN)                     :: rs0
-   REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:)       :: rd1
-   REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:)       :: rs1
-   REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:, :)    :: rd2
-   REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:, :)    :: rs2
-   REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rd3  
-   REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rs3
+      CHARACTER(len = *), INTENT(IN)                     :: sdfield
+      REAL(dp), OPTIONAL, INTENT(IN)                     :: rd0
+      REAL(sp), OPTIONAL, INTENT(IN)                     :: rs0
+      REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:)       :: rd1
+      REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:)       :: rs1
+      REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:, :)    :: rd2
+      REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:, :)    :: rs2
+      REAL(dp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rd3  
+      REAL(sp), OPTIONAL, INTENT(IN), DIMENSION(:, :, :) :: rs3
 #if defined key_iomput
-   TYPE(xios_field) :: field_hdl
-   TYPE(xios_file) :: file_hdl
-   INTEGER :: i
-   CHARACTER(lc)  ::   clpath
-   CHARACTER(len=1024) :: fname
-   CHARACTER(len=lc)   :: axis_ref
-
-        CALL xios_get_handle("wrestart", file_hdl)
+      TYPE(xios_field) :: field_hdl
+      TYPE(xios_file) :: file_hdl
+
+      CALL xios_get_handle("wrestart", file_hdl)
 !define fields for restart context
-        CALL xios_add_child(file_hdl, field_hdl, TRIM(sdfield))
-
-        IF(PRESENT(rd3)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield),   &
-                            domain_ref="grid_N", axis_ref=TRIM(iom_axis(size(rd3, 3))), &
-                            prec = 8, operation = "instant")
-        ELSEIF(PRESENT(rs3)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield),   &
-                            domain_ref="grid_N", axis_ref=TRIM(iom_axis(size(rd3, 3))), &
-                            prec = 4, operation = "instant")
-        ELSEIF(PRESENT(rd2)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                   domain_ref="grid_N", prec = 8, operation = "instant") 
-        ELSEIF(PRESENT(rs2)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                   domain_ref="grid_N", prec = 4, operation = "instant")
-        ELSEIF(PRESENT(rd1)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                   axis_ref=TRIM(iom_axis(size(rd1, 1))), prec = 8, operation = "instant")
-        ELSEIF(PRESENT(rs1)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                   axis_ref=TRIM(iom_axis(size(rd1, 1))), prec = 4, operation = "instant")
-        ELSEIF(PRESENT(rd0)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                         scalar_ref = "grid_scalar", prec = 8, operation = "instant")
-        ELSEIF(PRESENT(rs0)) THEN
-               CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(sdfield), &
-                                         scalar_ref = "grid_scalar", prec = 4, operation = "instant")
-        ENDIF
+      CALL xios_add_child(file_hdl, field_hdl, sdfield)
+
+      IF(PRESENT(rd3)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             domain_ref = "grid_N",                       &
+                             axis_ref = iom_axis(size(rd3, 3)),           &
+                             prec = 8, operation = "instant"              )
+      ELSEIF(PRESENT(rs3)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             domain_ref = "grid_N",                       &
+                             axis_ref = iom_axis(size(rd3, 3)),           &
+                             prec = 4, operation = "instant"              )
+      ELSEIF(PRESENT(rd2)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             domain_ref = "grid_N", prec = 8,             &
+                             operation = "instant"                        ) 
+      ELSEIF(PRESENT(rs2)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             domain_ref = "grid_N", prec = 4,             &
+                             operation = "instant"                        )
+      ELSEIF(PRESENT(rd1)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             axis_ref = iom_axis(size(rd1, 1)),           &
+                             prec = 8, operation = "instant"              )
+      ELSEIF(PRESENT(rs1)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             axis_ref = iom_axis(size(rd1, 1)),           &
+                             prec = 4, operation = "instant"              )
+      ELSEIF(PRESENT(rd0)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             scalar_ref = "grid_scalar", prec = 8,        &
+                             operation = "instant"                        )
+      ELSEIF(PRESENT(rs0)) THEN
+         CALL xios_set_attr (field_hdl, enabled = .TRUE., name = sdfield, &
+                             scalar_ref = "grid_scalar", prec = 4,        &
+                             operation = "instant"                        )
+      ENDIF
 #endif
    END SUBROUTINE iom_set_rstw_active
@@ -518,17 +527,17 @@
       !!              iom_set_rst_context
       !!---------------------------------------------------------------------
-    INTEGER, INTENT(IN) :: idlev
-    CHARACTER(len=lc)   :: axis_ref
-    CHARACTER(len=12)   :: str
-       IF(idlev == jpk) THEN
+      INTEGER, INTENT(IN) :: idlev
+      CHARACTER(len=lc)   :: axis_ref
+      CHARACTER(len=12)   :: str
+      IF(idlev == jpk) THEN
          axis_ref="nav_lev"
 #if defined key_si3
-       ELSEIF(idlev == jpl) THEN
+      ELSEIF(idlev == jpl) THEN
          axis_ref="numcat"
 #endif         
-       ELSE
+      ELSE
          write(str, *) idlev
          CALL ctl_stop( 'iom_axis', 'Definition for axis with '//TRIM(ADJUSTL(str))//' levels missing')
-       ENDIF
+      ENDIF
    END FUNCTION iom_axis
 
@@ -541,31 +550,30 @@
       !!               
       !!---------------------------------------------------------------------
-   LOGICAL, INTENT(IN)               :: ld_rstr
-   INTEGER :: ji
+      LOGICAL, INTENT(IN)               :: ld_rstr
+      INTEGER :: ji
 #if defined key_iomput
-   TYPE(xios_domaingroup)            :: domaingroup_hdl 
-   TYPE(xios_domain)                 :: domain_hdl 
-   TYPE(xios_axisgroup)              :: axisgroup_hdl 
-   TYPE(xios_axis)                   :: axis_hdl 
-   TYPE(xios_scalar)                 :: scalar_hdl 
-   TYPE(xios_scalargroup)            :: scalargroup_hdl 
-
-     CALL xios_get_handle("domain_definition",domaingroup_hdl) 
-     CALL xios_add_child(domaingroup_hdl, domain_hdl, "grid_N") 
-     CALL set_grid("N", glamt, gphit, .TRUE., ld_rstr) 
+      TYPE(xios_domaingroup)            :: domaingroup_hdl 
+      TYPE(xios_domain)                 :: domain_hdl 
+      TYPE(xios_axisgroup)              :: axisgroup_hdl 
+      TYPE(xios_axis)                   :: axis_hdl 
+      TYPE(xios_scalar)                 :: scalar_hdl 
+      TYPE(xios_scalargroup)            :: scalargroup_hdl 
+
+      CALL xios_get_handle("domain_definition",domaingroup_hdl) 
+      CALL xios_add_child(domaingroup_hdl, domain_hdl, "grid_N") 
+      CALL set_grid("N", glamt, gphit, .TRUE., ld_rstr) 
  
-     CALL xios_get_handle("axis_definition",axisgroup_hdl) 
-     CALL xios_add_child(axisgroup_hdl, axis_hdl, "nav_lev") 
+      CALL xios_get_handle("axis_definition",axisgroup_hdl) 
+      CALL xios_add_child(axisgroup_hdl, axis_hdl, "nav_lev") 
 !AGRIF fails to compile when unit= is in call to xios_set_axis_attr
-!    CALL xios_set_axis_attr( "nav_lev", long_name="Vertical levels",  unit="m", positive="down") 
-     CALL xios_set_axis_attr( "nav_lev", long_name="Vertical levels in meters", positive="down")
-     CALL iom_set_axis_attr( "nav_lev", paxis = gdept_1d ) 
+!     CALL xios_set_axis_attr( "nav_lev", long_name="Vertical levels",  unit="m", positive="down") 
+      CALL xios_set_axis_attr( "nav_lev", long_name = "Vertical levels in meters", positive = "down")
+      CALL iom_set_axis_attr( "nav_lev", paxis = gdept_1d ) 
 #if defined key_si3
-     CALL xios_add_child(axisgroup_hdl, axis_hdl, "numcat")
-     CALL iom_set_axis_attr( "numcat", (/ (REAL(ji,wp), ji=1,jpl) /) )
-#endif
-
-     CALL xios_get_handle("scalar_definition", scalargroup_hdl) 
-     CALL xios_add_child(scalargroup_hdl, scalar_hdl, "grid_scalar") 
+      CALL xios_add_child(axisgroup_hdl, axis_hdl, "numcat")
+      CALL iom_set_axis_attr( "numcat", (/ (REAL(ji,wp), ji=1,jpl) /) )
+#endif
+      CALL xios_get_handle("scalar_definition", scalargroup_hdl) 
+      CALL xios_add_child(scalargroup_hdl, scalar_hdl, "grid_scalar") 
 #endif
    END SUBROUTINE iom_set_rst_context
@@ -1526,9 +1534,9 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-          IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
-          CALL iom_put(trim(cdvar), pvar)
+         IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
+         CALL iom_put(trim(cdvar), pvar)
       ELSE
-          IF(lwp) write(numout,*) 'RESTART: define (XIOS 0D) ',trim(cdvar)
-          CALL iom_set_rstw_active( trim(cdvar), rs0 = pvar ) 
+         IF(lwp) write(numout,*) 'RESTART: define (XIOS 0D) ',trim(cdvar)
+         CALL iom_set_rstw_active( trim(cdvar), rs0 = pvar ) 
       ENDIF
 #endif
@@ -1559,9 +1567,9 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-          IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
-          CALL iom_put(trim(cdvar), pvar)
+         IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
+         CALL iom_put(trim(cdvar), pvar)
       ELSE
-          IF(lwp) write(numout,*) 'RESTART: define (XIOS 0D) ',trim(cdvar)
-          CALL iom_set_rstw_active( trim(cdvar), rd0 = pvar ) 
+         IF(lwp) write(numout,*) 'RESTART: define (XIOS 0D) ',trim(cdvar)
+         CALL iom_set_rstw_active( trim(cdvar), rd0 = pvar ) 
       ENDIF
 #endif
@@ -1729,5 +1737,5 @@
          IF(lwp) write(numout,*) 'RESTART: write (XIOS 3D) ',trim(cdvar)
          CALL iom_put(trim(cdvar), pvar)
-     ELSE
+      ELSE
          IF(lwp) write(numout,*) 'RESTART: define (XIOS 3D)',trim(cdvar)
          CALL iom_set_rstw_active( trim(cdvar), rs3 = pvar )
@@ -2135,5 +2143,5 @@
       CALL iom_swap( cdname )   ! swap to cdname context
       CALL xios_update_calendar(kt)
-      IF( cdname /= TRIM(cxios_context) )   CALL iom_swap( TRIM(cxios_context) )   ! return back to nemo context
+      IF( cdname /= TRIM(cxios_context) )   CALL iom_swap( cxios_context )   ! return back to nemo context
    END SUBROUTINE iom_setkt
 
